$warnings_hash = {}

#Chimeras
$warnings_hash['solved'] = 'SOLVED'

#Ncrna
$warnings_hash['<200nt'] = 'Sequence length < 200 nt'

#Artifacts
$warnings_hash['ERROR#1'] = 'ERROR#1, contains sense and antisense hits!!!, putative chimeric sequence, ' 
$warnings_hash['ERROR#2'] = 'ERROR#2, query has several hsps that overlaps on same protein zone'
$warnings_hash['ERROR#3'] = 'ERROR#3, Sequence has a lot of errors or reference protein is too different'

#FL_analisys
$warnings_hash['PositionResult'] = 'Selected protein is hit number (*replace*) in blast result, '
$warnings_hash['SingleResult'] = 'Selected protein is the only available option, '
$warnings_hash['noM1'] = 'W1: There is no M at the beginning, possible sequencing error, '
$warnings_hash['UnexpSTOP5p'] = ' Unexpected STOP codon in 5 prime region, '
$warnings_hash['NoStopMfar'] = 'No stop codon before M and M found is too far from subject M, '
$warnings_hash['noM2'] = 'W2: There is no M at the beginning, '
$warnings_hash['UnexpSTOP3p'] = ' Unexpected STOP codon at 3\' end. '
$warnings_hash['UnexpSTOP3pDist'] = ' Unexpected STOP codon at 3\' end. Distance to subject end: (*replace*) aas, '
$warnings_hash['DistSubj'] = 'Distance to subject end: (*replace*) aas, not enough to search stop codon'
$warnings_hash['qStopTooFar'] = 'query STOP codon too far from subject stop. Distance to subject end: (*replace*) aas, putative chimeric sequence,'
$warnings_hash['qStopFar'] = 'query STOP codon is far from subject stop. Distance to subject end: (*replace*) aas,'
$warnings_hash['noStopDist'] = ' STOP codon was not found. Distance to subject end: (*replace*) aas, ' 
$warnings_hash['UnexpStopBegSeq'] = 'Unexpected stop codon in the beginning of your sequence, ' 
$warnings_hash['SeqLonger'] = ' your sequence is longer than subject: (*replace*) - (*replace*)' 
$warnings_hash['SeqShorter'] = 'your sequence is shorter than subject: (*replace*) - (*replace*)' 
$warnings_hash['VeryShorter'] = '. Was predicted as Complete, but is very much shorter than subject'
$warnings_hash['NoStop'] = ' STOP codon was not found, '
$warnings_hash['ProtFusion'] = ' Possible protein fusion, '
$warnings_hash['QueryTooLong'] = ' Query too long, '
$warnings_hash['ExFrameS'] = ' Frameshift at (*replace*) (ex), '

#UneLosHit
$warnings_hash['OverlapHit'] = 'Overlapping hits, possible frame ERROR between (*replace*) and (*replace*), '
$warnings_hash['AndOverlapHit'] = ' and overlapping frame ERROR between (*replace*) and (*replace*), ' 
$warnings_hash['SeparatedHit'] = 'Separated hits, possible frame ERROR between (*replace*) and (*replace*), ' 
$warnings_hash['AndSeparatedHit'] = ' and possible frame ERROR between (*replace*) and (*replace*), '
