
class Orf
	
	attr_accessor :seq,:t_start,:t_end,:frame,:stop_codon,:type,:status,:score, :more_than_one_frame
	
	def initialize(orf_seq, t_start, t_end, frame, stop_codon, type)
		@seq=orf_seq
		@t_start=t_start
		@t_end=t_end
		@frame=frame
		@stop_codon=stop_codon
		@type=type # :N_terminus,:C_terminus,:Complete,:Internal,:Putative_Complete,:Putative_N_terminus
		@status = :unknown # :unknown,:putative_coding,:coding
		@score = 0
		@more_than_one_frame = false
	end
	
	def overlaps?(other_orf)
		overlap_status = false
		i1 = self.t_start
		i2 = other_orf.t_start
		e1 = self.t_end
		e2 = other_orf.t_end
		
		if (e1 > i2) && (e1 < e2)
			overlap_status = true
		end
		
		return overlap_status
	end
	
end