# -*- encoding: utf-8 -*-
# stub: full_lengther_next 1.0.1 ruby lib

Gem::Specification.new do |s|
  s.name = "full_lengther_next".freeze
  s.version = "1.0.1"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["Pedro Seoane".freeze, "Noe Fernandez".freeze, "Dario Guerrero".freeze]
  s.date = "2018-03-12"
  s.description = "FULL-LENGTHERNEXT is a tool adapted to NGS technologies, able to work in parallel and in a distributed way to minimise computing time. It is able to classify unigenes to full-length, 5\u2019-end, 3\u2019-end and internal, suggesting which unknown genes are coding or not. It will be also shown that FULL-LENGTHERNEXT fixes frame shifts, one of the main mistake found in wrong entries of full-length sequences databases, and it is a fast tool to compare different transcriptome assemblies.".freeze
  s.email = ["seoanezonjic@hotmail.com".freeze, "noeisneo@gmail.com".freeze, "dariogf@gmail.com".freeze]
  s.executables = ["console".freeze, "download_fln_dbs.rb".freeze, "full_lengther_next".freeze, "make_test_dataset.rb".freeze, "make_user_db.rb".freeze, "setup".freeze]
  s.files = ["bin/console".freeze, "bin/download_fln_dbs.rb".freeze, "bin/full_lengther_next".freeze, "bin/make_test_dataset.rb".freeze, "bin/make_user_db.rb".freeze, "bin/setup".freeze]
  s.homepage = "https://github.com/seoanezonjic".freeze
  s.licenses = ["MIT".freeze]
  s.rubygems_version = "3.2.22".freeze
  s.summary = "Tool to annotate transcriptomes and it is able to stablish the integrity of each transcript. Also, FLN can detect novel genes on a target organism.".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_runtime_dependency(%q<xml-simple>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<scbi_fasta>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<scbi_blast>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<scbi_mapreduce>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<scbi_zcat>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<bio-cd-hit-report>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<report_html>.freeze, [">= 0"])
    s.add_development_dependency(%q<bundler>.freeze, ["~> 1.12"])
    s.add_development_dependency(%q<rake>.freeze, ["~> 10.0"])
    s.add_development_dependency(%q<rspec>.freeze, ["~> 3.0"])
  else
    s.add_dependency(%q<xml-simple>.freeze, [">= 0"])
    s.add_dependency(%q<scbi_fasta>.freeze, [">= 0"])
    s.add_dependency(%q<scbi_blast>.freeze, [">= 0"])
    s.add_dependency(%q<scbi_mapreduce>.freeze, [">= 0"])
    s.add_dependency(%q<scbi_zcat>.freeze, [">= 0"])
    s.add_dependency(%q<bio-cd-hit-report>.freeze, [">= 0"])
    s.add_dependency(%q<report_html>.freeze, [">= 0"])
    s.add_dependency(%q<bundler>.freeze, ["~> 1.12"])
    s.add_dependency(%q<rake>.freeze, ["~> 10.0"])
    s.add_dependency(%q<rspec>.freeze, ["~> 3.0"])
  end
end
